package sun.awt;

import java.awt.Component;
import java.awt.event.FocusEvent;

public class CausedFocusEvent extends FocusEvent
{
    private final CausedFocusEvent.Cause cause;
    
    public CausedFocusEvent.Cause getCause() {
        return this.cause;
    }
    
    @Override
    public String toString() {
        return "java.awt.FocusEvent[" + super.paramString() + ",cause=" + this.cause + "] on " + this.getSource();
    }
    
    public CausedFocusEvent(Component source, int id, boolean temporary, Component opposite, CausedFocusEvent.Cause unknown) {
        super(source, id, temporary, opposite);
        if (unknown == null) {
            unknown = CausedFocusEvent.Cause.UNKNOWN;
        }
        this.cause = unknown;
    }
    
    public static FocusEvent retarget(FocusEvent focusEvent, Component component) {
        if (focusEvent == null) {
            return null;
        }
        return new CausedFocusEvent(component, focusEvent.getID(), focusEvent.isTemporary(), focusEvent.getOppositeComponent(), (focusEvent instanceof CausedFocusEvent) ? ((CausedFocusEvent)focusEvent).getCause() : CausedFocusEvent.Cause.RETARGETED);
    }
    
    public enum Cause
    {
        UNKNOWN, 
        MOUSE_EVENT, 
        TRAVERSAL, 
        TRAVERSAL_UP, 
        TRAVERSAL_DOWN, 
        TRAVERSAL_FORWARD, 
        TRAVERSAL_BACKWARD, 
        MANUAL_REQUEST, 
        AUTOMATIC_TRAVERSE, 
        ROLLBACK, 
        NATIVE_SYSTEM, 
        ACTIVATION, 
        CLEAR_GLOBAL_FOCUS_OWNER, 
        RETARGETED;
    }
}
